-- dirty hack
-- larsson - whybill@gmail.com
-- gpl

TITAN_EasyDKP_ID = "EasyDKP";
TITAN_EasyDKP_BUTTON_LABEL = "EDKP";
TITAN_EasyDKP_VERSION = "0.0.7";

-- default settings
TitanEasyDKPData = {
	enabled = true,
	mode = "party",
	debug = false,
	min_quality = 3,
	max_quality = 6,
}

TitanEasyDKPGData = {
	latest_version_seen = TITAN_EasyDKP_VERSION,
	latest_version_seen_num = 0,
	latest_version_seen_user = "",
	version_num = 0,
}

-- first time check
local initTitanEasyDKPData = TitanEasyDKPData;


function TitanPanelEasyDKPButton_OnLoad()
	this.registry = {
		id = TITAN_EasyDKP_ID,
		category = "General",
		version = TITAN_EasyDKP_VERSION,
		-- menu header
		menuText = "EasyDKP",
		buttonTextFunction = "TitanPanelEasyDKPButton_GetButtonText", 
		tooltipTitle = "EasyDKP",
		tooltipTextFunction = "TitanPanelEasyDKPButton_GetTooltipText", 
		icon = "Interface\\AddOns\\TitanEasyDKP\\TitanEasyDKP.tga",
		iconWidth = 16,
		savedVariables = {
			ShowIcon = 1,
			ShowLabelText = 1,
			ShowColoredText = 1,
		}
	};	

        DEFAULT_CHAT_FRAME:AddMessage("larsson's TitanEasyDKP v"..TITAN_EasyDKP_VERSION.." loaded.");

 	--this:RegisterEvent("PLAYER_LEAVING_WORLD");
	--this:RegisterEvent("PLAYER_ENTERING_WORLD");
	-- ADDON_LOADED ondemand
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("CHAT_MSG_ADDON");

end

function TitanPanelEasyDKPButton_OnEvent()

--	if (event == "PLAYER_ENTERING_WORLD") then
--		this:RegisterEvent("ITEM_LOCK_CHANGED");
--	end
	if (event == "VARIABLES_LOADED") then
	    DEFAULT_CHAT_FRAME:AddMessage("TitanEasyDKP variables loaded.");
	    if (initTitanEasyDKPData == TitanEasyDKPData) then
    		-- No change - Must be new user
		DEFAULT_CHAT_FRAME:AddMessage("TitanEasyDKP: you are a new user.");
	    else
		-- Changed - Previous user
		DEFAULT_CHAT_FRAME:AddMessage("TitanEasyDKP: you are an old user.");
	    end
	    -- trigger SKOP
	    TitanEasyDKP_doupdates();

	    -- some random
	    math.randomseed(math.random(0,2147483647)+(GetTime()*1000));
	    -- timerbased version fire
	    -- local x = math.random(50, 52);
	    -- http://www.wowwiki.com/HOWTO:_Use_OnUpdate_correct
	    -- do version conv here
	    
	    -- simple version announce
	    -- do mec for joining PARTY and RAID - "PARTY/RAID"
	    SendAddonMessage("TEDKP", "V\t"..TITAN_EasyDKP_VERSION, "GUILD");
	end

	if (event == "CHAT_MSG_ADDON") then
	    -- arg1 = prefix
	    -- arg2 = message
	    -- arg3 = distrib type
	    -- arg4 = sender
	    if(arg1 == "TEDKP") then
		-- change to array data.. 100% comp in future :P
		local a,b, mtype, mdata = string.find(arg2, "(.+)\t(.+)");
--		DEFAULT_CHAT_FRAME:AddMessage("TitanEasyDKP: Addon Chat message:"..mtype);
		if(mtype == "V") then
		    -- if version is higher add it
		    -- if lower trigger sending of our own stupid?
		    TitanEasyDKP_versioncheck(mdata, arg4);
--		DEFAULT_CHAT_FRAME:AddMessage("TitanEasyDKP: Addon Chat message:"..mtype);

		    if(TitanEasyDKPData.debug) then
			DEFAULT_CHAT_FRAME:AddMessage("TitanEasyDKP: Addon message version from user:'"..arg4.."'");
			DEFAULT_CHAT_FRAME:AddMessage("TitanEasyDKP: Latest version known to you is '"..TitanEasyDKPGData.latest_version_seen.."' from user '"..TitanEasyDKPGData.latest_version_seen_user.."'");
		    end
		end
	    end
	end

	-- really need to update on all reg events?
	-- TitanPanelButton_UpdateButton(TITAN_EasyDKP_ID);
end

function TitanEasyDKP_doupdates()
	-- move this into SKOP, (until fixed)
	if(TitanEasyDKPData.enabled == true) then
	    SKOP_command(TEXT("on"));
	    if (not TitanGetVar(TITAN_EasyDKP_ID,"Enabled")) then
		    TitanToggleVar(TITAN_EasyDKP_ID, "Enabled");
	    end
	end	      
	-- all toggle functions are broken :) (until fixed)
	if(TitanEasyDKPData.debug == true) then
	    SKOP_command(TEXT("debug"));
	    if (not TitanGetVar(TITAN_EasyDKP_ID,"Debug")) then
		    TitanToggleVar(TITAN_EasyDKP_ID, "Debug");
	    end
	end	      
	if(TitanEasyDKPData.mode == "party") then
	    SKOP_command(TEXT("party"));
	else
	    SKOP_command(TEXT("raid"));
	end	      

end

function TitanEasyDKP_versioncheck(str,user)
    if(TitanEasyDKPGData.latest_version_seen == str) then
	return;
    end
    
    local a,b, majors, minors, micros = string.find(str,"(.+)%.(.+)%.(.+)");
    local c,d, major, minor, micro = string.find(TitanEasyDKPGData.latest_version_seen, "(.+)%.(.+)%.(.+)");


-- quick and dirty, shift bits in lua?
    local test_version_num = (tonumber(micros) / 10000 ) + (tonumber(minors) / 100) + tonumber(majors);
    local latest_version_num = (tonumber(micro) /   10000 ) + (tonumber(minor) / 100) + tonumber(major);


    if(latest_version_num < test_version_num) then
	TitanEasyDKPGData.latest_version_seen_num = test_version_num;
	TitanEasyDKPGData.latest_version_seen = str;
	TitanEasyDKPGData.latest_version_seen_user = user;
	DEFAULT_CHAT_FRAME:AddMessage("TitanEasyDKP: Newer version is in use. '"..TitanEasyDKPGData.latest_version_seen.."'");
    end
end

function TitanPanelEasyDKPButton_OnClick(button)
	if (button == "LeftButton") then
	    SKOP_command(TEXT("gui"));
	end
end

function TitanPanelEasyDKPButton_GetButtonText(id)
	return TITAN_EasyDKP_BUTTON_LABEL, "";
end

--
--	Change to get status from SKOP
--
function TitanPanelEasyDKPButton_GetTooltipText()
    local ret = "";
    ret = EasyDKP_ReturnStatus(nil);
    return ret;
end

function TitanPanelRightClickMenu_PrepareEasyDKPMenu()
	TitanPanelRightClickMenu_AddTitle(TitanPlugins[TITAN_EasyDKP_ID].menuText);

	-- fixme, change to simple menu
	local info = {};
	info.text = "OnOff";
	info.func = TitanPanelEasyDKPButton_Enabled;
	info.checked = TitanUtils_Toggle(TitanEasyDKPData.enabled);
	UIDropDownMenu_AddButton(info);

--	local info = {};
--	info.text = "Mode";
--	info.func = TitanPanelEasyDKPButton_Mode;
--	info.checked = TitanUtils_Toggle(TitanGetVar(TITAN_EasyDKP_ID, "Mode"));
--	UIDropDownMenu_AddButton(info);

	local info = {};
	info.text = "Debug";
	info.func = TitanPanelEasyDKPButton_Debug;
	info.checked = TitanUtils_Toggle(TitanGetVar(TITAN_EasyDKP_ID, "Debug"));
	UIDropDownMenu_AddButton(info);

	TitanPanelRightClickMenu_AddSpacer();
	TitanPanelRightClickMenu_AddToggleIcon(TITAN_EasyDKP_ID);
	TitanPanelRightClickMenu_AddToggleLabelText(TITAN_EasyDKP_ID);
	TitanPanelRightClickMenu_AddToggleColoredText(TITAN_EasyDKP_ID);

--	TitanPanelRightClickMenu_AddToggleIcon(TITAN_ID);
--	TitanPanelRightClickMenu_AddToggleLabelText(TITAN_ID);


	TitanPanelRightClickMenu_AddSpacer();
	TitanPanelRightClickMenu_AddCommand(TITAN_PANEL_MENU_HIDE, TITAN_EasyDKP_ID, TITAN_PANEL_MENU_FUNC_HIDE);
end

function TitanEasyDKP_Test()
	PlaySoundFile("Sound\\interface\\mapping.wav");
end
      -- TitanPanelEasyDKPButton_Enabled
function TitanPanelEasyDKPButton_Enabled()

	TitanToggleVar(TITAN_EasyDKP_ID, "Enabled");
	PlaySoundFile("Sound\\interface\\mapping.wav");

-- change to toggle
-- change to general sweep "event" call at end of all blocks.. only use the vars in that block!
	if (TitanGetVar(TITAN_EasyDKP_ID, "Enabled")) then
    	    SKOP_command(TEXT("off"));
	    TitanEasyDKPData.enabled = false;
	else
	    SKOP_command(TEXT("on"));
	    TitanEasyDKPData.enabled = true;
	end

--	DKP2_SlashCommandHandler(TEXT(format("display raid raid sacina")));
-- if	info.checked = TitanGetVar(TITAN_EasyDKP_ID, "Enabled");
-- do else


	TitanPanelButton_UpdateButton(TITAN_EasyDKP_ID);
end


function TitanPanelEasyDKPButton_Mode()

	TitanToggleVar(TITAN_EasyDKP_ID, "Mode");
	PlaySoundFile("Sound\\interface\\mapping.wav");

	if (TitanEasyDKPData.mode == "raid") then
    	    SKOP_command(TEXT("party"));
	    TitanEasyDKPData.mode = "party";
	else
	    SKOP_command(TEXT("raid"));
	    TitanEasyDKPData.mode = "raid";
	end
	TitanPanelButton_UpdateButton(TITAN_EasyDKP_ID);
end

function TitanPanelEasyDKPButton_Debug()

	TitanToggleVar(TITAN_EasyDKP_ID, "Debug");
	PlaySoundFile("Sound\\interface\\mapping.wav");

	if (TitanGetVar(TITAN_EasyDKP_ID, "Debug")) then
    	    SKOP_command(TEXT("debug"));
	else
	    SKOP_command(TEXT("debug"));
	end
	-- ugly but quick
	TitanEasyDKPData.debug = EasyDKP_ReturnDebugStatus();
	
	TitanPanelButton_UpdateButton(TITAN_EasyDKP_ID);
end

